## cutefish-core 0.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(core)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(QT Core Gui Widgets Quick QuickControls2 DBus Xml X11Extras LinguistTools)
find_package(Qt5 REQUIRED ${QT})
# find_package(FishUI REQUIRED)
find_package(PkgConfig REQUIRED)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH})

include(GNUInstallDirs)

add_subdirectory(polkit-agent)
add_subdirectory(screen-brightness)
add_subdirectory(session)
add_subdirectory(settings-daemon)
add_subdirectory(shutdown-ui)
add_subdirectory(xembed-sni-proxy)
add_subdirectory(powerman)
add_subdirectory(cpufreq)
add_subdirectory(chotkeys)
add_subdirectory(cupdatecursor)
add_subdirectory(gmenuproxy)
add_subdirectory(notificationd)
add_subdirectory(sddm-helper)
add_subdirectory(clipboard)

install(FILES cutefish DESTINATION /etc/ COMPONENT Runtime)

=== clipboard/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(cutefish-clipboard LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Qt5 COMPONENTS Core Gui Widgets REQUIRED)

add_executable(cutefish-clipboard
  main.cpp
  clipboard.cpp
)
target_link_libraries(cutefish-clipboard
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
)

install(TARGETS cutefish-clipboard DESTINATION ${CMAKE_INSTALL_BINDIR})

=== cpufreq/CMakeLists.txt ===
project(cutefish-cpufreq)
set(TARGET cutefish-cpufreq)

set(SOURCES
    main.cpp
)

add_executable(${TARGET} ${SOURCES} ${DBUS_SOURCES})
target_link_libraries(${TARGET}
        Qt5::Core
        Qt5::Quick
        Qt5::DBus
        Qt5::X11Extras
)

configure_file(
    com.cutefish.cpufreq.pkexec.policy.in
    com.cutefish.cpufreq.pkexec.policy
    @ONLY
)

install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/com.cutefish.cpufreq.pkexec.policy DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/polkit-1/actions/)

=== cupdatecursor/CMakeLists.txt ===
find_package(Qt5 COMPONENTS Core Gui X11Extras REQUIRED)
find_package(X11)

add_executable(cupdatecursor
  main.cpp
)
target_link_libraries(cupdatecursor
    Qt5::Core
    Qt5::Gui
    Qt5::X11Extras
    ${X11_LIBRARIES}
    X11::X11
    X11::Xi
    X11::Xcursor
)

install(TARGETS cupdatecursor DESTINATION ${CMAKE_INSTALL_BINDIR})

=== gmenuproxy/CMakeLists.txt ===
find_package(AppMenuGtkModule)
find_package(KF5WindowSystem)
find_package(KF5CoreAddons)
set_package_properties(AppMenuGtkModule PROPERTIES TYPE RUNTIME)

add_definitions(-DQT_NO_CAST_TO_ASCII
-DQT_NO_CAST_FROM_ASCII
-DQT_NO_CAST_FROM_BYTEARRAY)

find_package(XCB
    REQUIRED COMPONENTS
        XCB
)

set(GMENU_DBUSMENU_PROXY_SRCS
    extend/dbusmenutypes_p.cpp
#    extend/dbusmenushortcut_p.cpp

    main.cpp
    menuproxy.cpp
    window.cpp
    menu.cpp
    actions.cpp
    dbusmenuadaptor.cpp
    gdbusmenutypes_p.cpp
    icons.cpp
    utils.cpp
 )

# qt_add_dbus_adaptor(GMENU_DBUSMENU_PROXY_SRCS ./com.canonical.dbusmenu.xml window.h Window)

add_executable(cutefish-gmenuproxy ${GMENU_DBUSMENU_PROXY_SRCS})

set_package_properties(XCB PROPERTIES TYPE REQUIRED)

target_link_libraries(cutefish-gmenuproxy
    Qt5::Core
    Qt5::X11Extras
    Qt5::DBus
    Qt5::Widgets
    KF5::CoreAddons
    KF5::WindowSystem
    XCB::XCB
)

configure_file(
    cutefish-gmenuproxy.service.in
    cutefish-gmenuproxy.service
    @ONLY
)

install(TARGETS cutefish-gmenuproxy DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cutefish-gmenuproxy.service DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/user/)

=== notificationd/CMakeLists.txt ===
set(SRCS main.cpp
         application.cpp
         datehelper.cpp
         screenhelper.cpp
         notificationsmodel.cpp
         notificationserver.cpp
         notification.cpp
         notificationpopup.cpp
         notificationwindow.cpp
         historymodel.cpp
         settings.cpp
         utils.cpp
         dbus/notificationsadaptor.cpp
         resources.qrc
)

# for Ubuntu
# qt_add_dbus_adaptor(SRCS org.freedesktop.Notifications.xml notificationserver.h NotificationServer)

qt5_add_dbus_adaptor(DBUS_SOURCES com.cutefish.Notification.xml application.h Application)
set_source_files_properties(${DBUS_SOURCES} PROPERTIES SKIP_AUTOGEN ON)

find_package(KF5WindowSystem)

add_executable(cutefish-notificationd ${SRCS} ${DBUS_SOURCES})

target_link_libraries(cutefish-notificationd
    Qt5::Core
    Qt5::DBus
    Qt5::Quick
    Qt5::Widgets
    KF5::WindowSystem
)

install(TARGETS cutefish-notificationd
    DESTINATION /usr/bin
    COMPONENT Runtime
)

file(GLOB TS_FILES translations/*.ts)
qt5_create_translation(QM_FILES ${TS_FILES})
add_custom_target(notificationd_translations DEPENDS ${QM_FILES} SOURCES ${TS_FILES})
add_dependencies(cutefish-notificationd notificationd_translations)

install(FILES ${QM_FILES} DESTINATION /usr/share/cutefish-notificationd/translations)

=== screen-brightness/CMakeLists.txt ===
project(cutefish-screen-brightness)
set(PROJECT_NAME cutefish-screen-brightness)

set(SRCS
    main.cpp
    brightnesshelper.h
    brightnesshelper.cpp
)

add_executable(${PROJECT_NAME}
    ${SRCS}
)

target_link_libraries(${PROJECT_NAME}
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
)

configure_file(
    com.cutefish.brightness.pkexec.policy.in
    com.cutefish.brightness.pkexec.policy
    @ONLY
)

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/com.cutefish.brightness.pkexec.policy DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/polkit-1/actions/)

=== sddm-helper/CMakeLists.txt ===
project(cutefish-sddm-helper)
set(PROJECT_NAME cutefish-sddm-helper)

set(SRCS
    main.cpp
)

add_executable(${PROJECT_NAME}
    ${SRCS}
)

target_link_libraries(${PROJECT_NAME}
        Qt5::Core
        Qt5::Gui
)

configure_file(
    com.cutefish.sddm.helper.pkexec.policy.in
    com.cutefish.sddm.helper.pkexec.policy
    @ONLY
)

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/com.cutefish.sddm.helper.pkexec.policy DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/polkit-1/actions/)

=== session/CMakeLists.txt ===
project(cutefish-session)
set(TARGET cutefish-session)

set(SOURCES
    application.cpp
    main.cpp
    process.cpp
    processmanager.cpp
    networkproxymanager.cpp

    powermanager/power.cpp
    powermanager/powerproviders.cpp
)

qt5_add_dbus_adaptor(DBUS_SOURCES
                     com.cutefish.Session.xml
                     application.h Application
                     sessionadaptor SessionAdaptor)
set_source_files_properties(${DBUS_SOURCES} PROPERTIES SKIP_AUTOGEN ON)

find_package(KF5WindowSystem)

add_executable(${TARGET} ${SOURCES} ${DBUS_SOURCES})
target_link_libraries(${TARGET}
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::Quick
        Qt5::DBus
        Qt5::X11Extras
        KF5::WindowSystem
)

install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES cutefish-xsession.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/xsessions/)

=== settings-daemon/CMakeLists.txt ===
project(cutefish-settings-daemon)
set(TARGET cutefish-settings-daemon)

find_package(X11 REQUIRED)
find_package(X11_XCB REQUIRED)
find_package(XCB REQUIRED)

pkg_check_modules(XORGLIBINPUT xorg-libinput IMPORTED_TARGET)
pkg_check_modules(XORGSERVER xorg-server IMPORTED_TARGET)
pkg_check_modules(SYNAPTICS xorg-synaptics IMPORTED_TARGET GLOBAL)

file (GLOB_RECURSE SRCS
  "*.cpp"
  "*.h"
  "theme/*.h"
  "theme/*.cpp"
  "brightness/*.h"
  "brightness/*.cpp"
  "brightness/*.c"
  "battery/*.cpp"
  "battery/*.h"
  "language/*.cpp"
  "language/*.h"
  "dock/*.cpp"
  "dock/*.h"
  "mouse/*.h"
  "mouse/*.cpp"
  "touchpad/*.h"
  "touchpad/*.cpp"
  "touchpad/x11/*.h"
  "touchpad/x11/*.cpp"
)

set(SOURCES ${SRCS})
set(HEADERS "")
set(FORMS "")
set(RESOURCES "")

qt5_add_dbus_adaptor(DBUS_SOURCES
                     brightness/com.cutefish.Brightness.xml
                     brightness/brightnessmanager.h BrightnessManager)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     theme/com.cutefish.Theme.xml
                     theme/thememanager.h ThemeManager)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     battery/com.cutefish.PrimaryBattery.xml
                     battery/battery.h Battery)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     language/com.cutefish.Language.xml
                     language/language.h Language)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     dock/com.cutefish.Dock.xml
                     dock/dock.h Dock)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     mouse/com.cutefish.Mouse.xml
                     mouse/mousemanager.h Mouse)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     touchpad/com.cutefish.Touchpad.xml
                     touchpad/touchpadmanager.h TouchpadManager)
set_source_files_properties(${DBUS_SOURCES} PROPERTIES SKIP_AUTOGEN ON)

add_executable(${TARGET} ${SOURCES} ${DBUS_SOURCES} ${HEADERS} ${FORMS} ${RESOURCES})
target_link_libraries(${TARGET}
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::DBus
        Qt5::X11Extras
        Qt5::Xml
        ${X11_LIBRARIES}
        X11::X11
        X11::Xi
        X11::XCB
        ${XCB_LIBRARIES}
        PkgConfig::XORGLIBINPUT
        PkgConfig::XORGSERVER
        PkgConfig::SYNAPTICS
)

file(GLOB TS_FILES translations/*.ts)
qt5_create_translation(QM_FILES ${TS_FILES})
add_custom_target(translations DEPENDS ${QM_FILES} SOURCES ${TS_FILES})
add_dependencies(${TARGET} translations)

install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${TARGET}/translations)

=== shutdown-ui/CMakeLists.txt ===
project(cutefish-shutdown)

add_executable(cutefish-shutdown
    main.cpp
    actions.cpp
    qml.qrc
)

target_link_libraries(cutefish-shutdown
        Qt5::Core
        Qt5::Widgets
        Qt5::Quick
        Qt5::QuickControls2
        Qt5::DBus
)

file(GLOB TS_FILES translations/*.ts)
qt5_create_translation(QM_FILES ${TS_FILES})
add_custom_target(shutdown-translations DEPENDS ${QM_FILES} SOURCES ${TS_FILES})
add_dependencies(cutefish-shutdown shutdown-translations)
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/cutefish-shutdown/translations)

install(TARGETS cutefish-shutdown RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== xembed-sni-proxy/CMakeLists.txt ===
project(cutefish-xembedsniproxy)

add_definitions(-DQT_NO_CAST_TO_ASCII
-DQT_NO_CAST_FROM_ASCII
-DQT_NO_URL_CAST_FROM_STRING
-DQT_NO_CAST_FROM_BYTEARRAY)

find_package(X11)
set_package_properties(X11 PROPERTIES DESCRIPTION "X11 libraries"
                        URL "http://www.x.org"
                        TYPE OPTIONAL
                        PURPOSE "Required for building the X11 based workspace")

if(X11_FOUND)
  find_package(XCB MODULE REQUIRED COMPONENTS XCB RANDR)
  set_package_properties(XCB PROPERTIES TYPE REQUIRED)
  if(NOT X11_SM_FOUND)
    message(FATAL_ERROR "\nThe X11 Session Management (SM) development package could not be found.\nPlease install libSM.\n")
  endif(NOT X11_SM_FOUND)

  find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS X11Extras)
endif()

if(X11_FOUND AND XCB_XCB_FOUND)
  set(HAVE_X11 1)
endif()

find_package(XCB
    REQUIRED COMPONENTS
        XCB
        XFIXES
        DAMAGE
        COMPOSITE
        RANDR
        SHM
        UTIL
        IMAGE
)

find_package(KF5WindowSystem)

set(XCB_LIBS
    XCB::XCB
    XCB::XFIXES
    XCB::DAMAGE
    XCB::COMPOSITE
    XCB::RANDR
    XCB::SHM
    XCB::UTIL
    XCB::IMAGE
)

set(XEMBED_SNI_PROXY_SOURCES
    main.cpp
    fdoselectionmanager.cpp
    snidbus.cpp
    sniproxy.cpp
    debug.cpp
    xtestsender.cpp
)

qt5_add_dbus_adaptor(DBUS_SOURCES org.kde.StatusNotifierItem.xml
                     sniproxy.h SNIProxy)
set(statusnotifierwatcher_xml org.kde.StatusNotifierWatcher.xml)
qt5_add_dbus_interface(DBUS_SOURCES ${statusnotifierwatcher_xml} statusnotifierwatcher_interface)

set_source_files_properties(${DBUS_SOURCES} PROPERTIES SKIP_AUTOGEN ON)

add_executable(cutefish-xembedsniproxy ${XEMBED_SNI_PROXY_SOURCES} ${DBUS_SOURCES})
set_package_properties(XCB PROPERTIES TYPE REQUIRED)
target_link_libraries(cutefish-xembedsniproxy
    Qt5::Core
    Qt5::X11Extras
    Qt5::DBus
    KF5::WindowSystem
    ${XCB_LIBS}
    ${X11_XTest_LIB}
)

install(TARGETS cutefish-xembedsniproxy DESTINATION ${CMAKE_INSTALL_BINDIR})

## cutefish-core 0.4

=== debian/changelog ===
cutefish-core (0.4-1) unstable; urgency=medium

  * Upload to unstable.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Sat, 27 Nov 2021 19:52:33 +0545

cutefish-core (0.4-1~exp1) experimental; urgency=medium

  * Initial release (Closes: #993448)

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Sun, 26 Sep 2021 01:49:27 +0545

=== debian/control ===
Source: cutefish-core
Section: devel
Priority: optional
Maintainer: Arun Kumar Pariyar <openarungeek@gmail.com>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 extra-cmake-modules,
 libkf5globalaccel-dev,
 libkf5windowsystem-dev,
 libpolkit-agent-1-dev,
 libpolkit-qt5-1-dev,
 libpulse-dev,
 libqt5x11extras5-dev,
 libsm-dev,
 libxcb-composite0-dev,
 libxcb-damage0-dev,
 libxcb-image0-dev,
 libxcb-keysyms1-dev,
 libxcb-randr0-dev,
 libxcb-shm0-dev,
 libxcb-util-dev,
 libxcb-xfixes0-dev,
 libxcb1-dev,
 libxcursor-dev,
 libxtst-dev,
 pkg-config,
 qtbase5-dev,
 qtdeclarative5-dev,
 qtquickcontrols2-5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 xserver-xorg-input-libinput-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/cutefishos/terminal
Vcs-Browser: https://salsa.debian.org/cutefish-team/cutefish-core
Vcs-Git: https://salsa.debian.org/cutefish-team/cutefish-core.git

Package: cutefish-core
Architecture: any
Depends:
 qml-module-qt-labs-platform,
 qml-module-qt-labs-settings,
 qml-module-qtqml,
 qml-module-qtquick-layouts,
 qml-module-qtquick-shapes,
 qml-module-qtquick-window2,
 qml-module-qtquick2,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Cutefish core system components and backend
 Cutefish core system components and backend for Cutefish desktop environment.
 .
 This package is a part of Cutefish DE.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic

export QT_SELECT := 5

%:
	dh $@

## cutefish-core 0.8

=== debian/changelog ===
cutefish-core (0.8-1) unstable; urgency=medium

  * New upstream release 0.8.
  * Add postinst and prerm scripts.
  * debian/control:
    + Refresh dependencies.
    + Fix Homepage URL (Closes: #1000840)
  * debian/copyright:
    + Update copyright information.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Thu, 10 Feb 2022 22:26:52 +0545

=== debian/control ===
--- 
+++ 
@@ -6,18 +6,26 @@
  cmake,
  debhelper-compat (= 13),
  extra-cmake-modules,
+ libkf5coreaddons-dev,
  libkf5globalaccel-dev,
+ libkf5idletime-dev,
  libkf5windowsystem-dev,
  libpolkit-agent-1-dev,
  libpolkit-qt5-1-dev,
- libpulse-dev,
  libqt5x11extras5-dev,
  libsm-dev,
+ libx11-xcb-dev,
  libxcb-composite0-dev,
  libxcb-damage0-dev,
+ libxcb-dpms0-dev,
+ libxcb-dri2-0-dev,
+ libxcb-dri3-dev,
+ libxcb-ewmh-dev,
+ libxcb-glx0-dev,
  libxcb-image0-dev,
  libxcb-keysyms1-dev,
  libxcb-randr0-dev,
+ libxcb-record0-dev,
  libxcb-shm0-dev,
  libxcb-util-dev,
  libxcb-xfixes0-dev,
@@ -30,19 +38,25 @@
  qtquickcontrols2-5-dev,
  qttools5-dev,
  qttools5-dev-tools,
+ xserver-xorg-dev,
  xserver-xorg-input-libinput-dev,
+ xserver-xorg-input-synaptics-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.6.0
-Homepage: https://github.com/cutefishos/terminal
+Homepage: https://github.com/cutefishos/core
 Vcs-Browser: https://salsa.debian.org/cutefish-team/cutefish-core
 Vcs-Git: https://salsa.debian.org/cutefish-team/cutefish-core.git
 
 Package: cutefish-core
 Architecture: any
 Depends:
+ accountsservice,
+ appmenu-gtk2-module,
+ appmenu-gtk3-module,
  qml-module-qt-labs-platform,
  qml-module-qt-labs-settings,
  qml-module-qtqml,
+ qml-module-qtquick-controls2,
  qml-module-qtquick-layouts,
  qml-module-qtquick-shapes,
  qml-module-qtquick-window2,

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%core-$1.tar.gz%" \
   https://github.com/cutefishos/core/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
